define( ["js/app/widgets/imageSlideshow.widget.js"] , function(){
	
	
	var ArticleSlideshow = function(){
		this.$element = null;
		this.$originalElement = null;
		this.$reflowParent = null;
		this._shouldRecreate = true;
		this.slideshowWidget = null; 
		this._imageUrls = null;
	};

	ArticleSlideshow.prototype.init = function($element){
		
		//We need to detect if we are in the column flow
		if($element.parent().hasClass("columnsFT-fixed")){
			//get columnsFT directive
			this.$reflowParent = $element.parent().parent();
			//little sanity check
			if(!this.$reflowParent.attr("directive")=="columnsFT"){
				//console.error("shouldn't happen");
				this.$reflowParent = null;
			}
			//get actual columnsFT reflowed content:
			this.$reflowParent = $(".columnsFT-content" , this.$reflowParent);
		}
		
		//Parse DOM
		this.$element = $element;
		this.$originalElement = $element;
		
	};

	ArticleSlideshow.prototype.init2 = function($element){
		//wait for second init, when required scroller is initialized
		
	};


	ArticleSlideshow.prototype.applyModelChanges = function(changeMap){		
		if(!changeMap || changeMap.articleContent){
			//Get the slide show images
			this._imageUrls = null;
			var article = AF.reader.models.articleContent;
			if(article && article.media && article.media.photo && article.media.photo.length>0){
				this._imageUrls = [];
				for(var i=0 ; i<article.media.photo.length ; i++){
					this._imageUrls.push( AF.reader.getImageUrl( article.media.photo[i] ) ); 	
				}
			}
			
			//We need to define ASAP if we should display the slideshow or not
			//the reflow uses that information
			if(this._imageUrls){
				this.$originalElement.css("display","block"); 	
			}else{
				this.$originalElement.css("display","none");
			}
			
			//we have to delay the slideshow construction to the update method
			//because we need reflow to be computed 
			this._shouldRecreate = true;
		}
		return false;
	};

	ArticleSlideshow.prototype.update = function(){
		if(this._imageUrls){
			if(this._shouldRecreate){
				this._shouldRecreate = false;
				if(!this.slideshowWidget){
					this.slideshowWidget = new AF.widgets.imageSlideshow();
				}
				this.slideshowWidget.init(this._imageUrls)
			}
			//we need to find where $element has been cloned (reflow keeps removing everything) 
			//(note: For the moment, we assume there can be only one slideshow per reflow)
			this.$element = $('.cf-render-area div[directive="articleSlideshow"]' , this.$reflowParent);
			this.slideshowWidget.update(this.$element);
		}
	};


	
	ArticleSlideshow.order = 2; //updated after columns directive  
	AF.directives.articleSlideshow = ArticleSlideshow;
});
	
