define(["js!js/libs/jQuery/jquery.imagesloaded.js"], function(){
	
	
	var ImageDirective = function(){
		
	};

	ImageDirective.prototype.init = function($element){
		this.$element = $element;

		this.$element.css("overflow","hidden");
		
		this.src = null;
		this.$image = $(new Image());
		this.$nextImage = $(new Image());

		$element.append(this.$image);
		$element.append(this.$nextImage);

		/*
		//We are only interested in listening to the loading of the next image
		//but references are swapped afterwards
		var self = this;
		this.$element.imagesLoaded(function(){
			alert("loaded");
		});
		this.$nextImage.imagesLoaded(function(){
			self.nextImageLoaded(self.$nextImage);
		});
		this.$image.imagesLoaded(function(){
			self.nextImageLoaded(self.$image);
		});
		*/
		
		//TODO: make this settings if needed
		this.scaleMode = "fit";	
		this.ignoreNullChanges = true;
		this.transitionDuration = 200;
		
		this.loading = false;
	};

	ImageDirective.prototype.applyModelChanges = function(changeMap){
		return false;
	};

	ImageDirective.prototype.update = function(){
		this._placeImage(this.$image);
		this._placeImage(this.$nextImage);
	};
	
	
	ImageDirective.prototype.setSrc = function(src){
		if(src != this.src && (!this.ignoreNullChanges || src!=null)){
			this.$nextImage.stop();
			this.$nextImage.css("opacity",0);

			this.src  = src;
			
			if(src){
				var self = this;
				this.$element.imagesLoaded( function(){
					clearTimeout(self._timeoutId);
					//we need ot delay a little because otherwise natural size may be 0
					self._timeoutId = setTimeout( function(){
						self.nextImageLoaded(self.$nextImage);
					} , 100);
				} );

				this.$nextImage.css("opacity",0);
				this.$nextImage[0].src = src;
				this.loading = true;
			}else{
				//null source -> hide
				this.$image.animate( {opacity:0 } , this.duration , "swing" );
			}
		}
	};
	

	ImageDirective.prototype.nextImageLoaded = function($img){
		if($img == this.$nextImage){
			if(this.loading){
				this.$nextImage.css("opacity",0);
				this.$nextImage.delay(10).animate( {opacity:1 } , this.duration , "swing" , $.proxy(this.animationFinished , this));
				this.loading = false;

				this.update();
			}
		}
	};

	ImageDirective.prototype.animationFinished = function(){
		//swap vars
		var tmp = this.$image;
		this.$image = this.$nextImage;
		this.$nextImage = tmp;

		this.$image.stop();
		this.$image.css("opacity",1);
		this.$nextImage.stop();
		this.$nextImage.css("opacity",0);

		this.$image.css("z-index",0);
		this.$nextImage.css("z-index",1);
	};
	

	ImageDirective.prototype._placeImage = function($image){
		var scale ,
			w = this.$element.width(),
			h = this.$element.height(),
			imgw = $image[0].naturalWidth,
			imgh = $image[0].naturalHeight;
		
		if(this.scaleMode=="fit"){
			scale = Math.min( w/imgw , h/imgh);
		}else{
			scale = Math.max( w/imgw , h/imgh);
		}
		imgw = ~~(imgw*scale);
		imgh = ~~(imgh*scale);


		var x = (this.$element.innerWidth()-imgw)/2 ,
			y = (this.$element.innerHeight()-imgh)/2;

		$image.css({
			"position": "absolute",
			"left" : x+"px",
			"top" : y+"px",
			"width" : imgw+"px",
			"height" : imgh+"px"
		});
	};
	
	
	

	ImageDirective.order = 0;
	AF.directives.image = ImageDirective;
	
});
