define(["signals"] , function(signals){
	
	var HORIZONTAL = "horizontal",
		VERTICAL = "vertical";

	
	var ScrollCSS = function(){
		this.scrollSignal = new signals.Signal();
	};

	ScrollCSS.prototype.init = function($element){
		this.direction = $element.attr("scroll-direction") || VERTICAL;
		this.$element = $element;
		
		$element.data("af-scroll",this);

		var self = this;
		$element.scroll(function(){
			self.scrollSignal.dispatch();
		});
		
		if(this.direction == HORIZONTAL){
			$element.addClass("af-scrollX");
		}else{
			$element.addClass("af-scrollY");
		}
	};

	ScrollCSS.prototype.applyModelChanges = function(changeMap){
		return false;
	};
	
	ScrollCSS.prototype.update = function(){
		
	};
	
	ScrollCSS.prototype.getPosition = function(){
		if(this.direction == HORIZONTAL){
			return this.$element.scrollLeft();
		}else{
			return this.$element.scrollTop();
		}	
	};

	
	
	ScrollCSS.prototype.setPosition = function(value){
		if(this.direction == HORIZONTAL){
			this.$element.scrollLeft(value);
		}else{
			this.$element.scrollTop(value);
		}
	};

	ScrollCSS.prototype.getElementPosition = function($element){
		var position = $element.position(); //Relative to the parent
		if(this.direction == HORIZONTAL){
			return position.left + this.$element.scrollLeft();
		}else{
			return position.top + this.$element.scrollTop();
		}
	};

	ScrollCSS.order = 1;
	AF.directives.scrollCSS = ScrollCSS;
});