define( function(){
	
	
	var VBox = function(){
		
	};

	VBox.prototype.init = function($element){
		this.$element = $element;
		this.childrenArray = $element.children().toArray();
		this.$fixedChildrenArray = [];
		this.$expandChildrenArray = [];
		
		for(var i=0 ; i<this.childrenArray.length ; i++){
			//$childrenArray should be an array of jQuery object (as an optimization for update) 
			var $child = $(this.childrenArray[i]);
			
			if( $child.attr('vBox-expand') !== undefined ){
				this.$expandChildrenArray.push($child);
			}else{
				this.$fixedChildrenArray.push($child);
			}
		}
	};
	

	VBox.prototype.applyModelChanges = function(changeMap){
		return false;
	};

	VBox.prototype.update = function(){
		var	totalHeight = this.$element.height() ,
			lenExpandChildren = this.$expandChildrenArray.length;
		if(lenExpandChildren >= 1){
			var children = this.$fixedChildrenArray ,
				lenChild = children.length,
				fixedSize = 0;
			for(var iChild=0 ; iChild<lenChild ; iChild++){
				var $child = children[iChild],
					outerHeight = $child.outerHeight(true);

				fixedSize += outerHeight;
			}
			var expandSize = ~~( (totalHeight-fixedSize)/lenExpandChildren);
			children = this.$expandChildrenArray;
			for(iChild=0 ; iChild<lenExpandChildren ; iChild++){
				$child = children[iChild];
				$child.height(expandSize);
				//$child.css("border","solid purple 5px");
			}
		}
	};

	VBox.order = 0;
	AF.directives.vBox = VBox;
	
});
